import java.awt.*;

public class mCircle extends mRectangle {
  
  public mCircle( DrawCanvas _parent, 
		  int _x, int _y, int _x2, int _y2, 
		  String _color, String _fillcolor) {
    
    super(_parent, _x, _y, _x2, _y2, _color, _fillcolor);
  }
  
  public void draw(Graphics g) {
    if (fill) {
      g.setColor(parent.getHashedColor(fillcolor));
      g.fillOval(x, y, x2-x, y2-y);
    }
    g.setColor(parent.getHashedColor(color));
    g.drawOval(x, y, x2-x, y2-y);
  }
  
  public String toString() {
    
    String s = "drawOval "; 
    String coor = String.valueOf(x) + " " + String.valueOf(y) + " " +
      String.valueOf(x2) + " " + String.valueOf(y2) + " ";
    
    if (fill) return "fillOval " + coor + color + " " + fillcolor;
    else return "drawOval " + coor + color;
    
  }
}
