
//Title:        HSA Parents' Corner
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       Ozgur Balsoy
//Company:      
//Description:  Online Parental Access to the School Database

package hsa.util;
import java.io.*;
import java.util.*;

public class Log
{
  private static String fileName = "c:\\hsa\\hsa.log",
                        debugName = "c:\\hsa\\debug.log";
  private static boolean doLog = false;
  private static PrintWriter logFile, debugFile;
  public Log()
  {
  }

  public static void start()
  {
    try {
      if(logFile == null) {
        logFile = new PrintWriter( new FileWriter(fileName, true), true); // append, autoflush
        doLog = true;
        log("Starting logger...");
      }
    } catch(Exception e) {
      doLog = false;
    }
  }

  public static void log(String message)
  {
    start();
    try {
      if(doLog) {
        Calendar rightNow = Calendar.getInstance();
        logFile.println("[" +rightNow.getTime().toString() + "] " +message);
      }
    } catch(Exception e) {
      doLog = false;
    }
  }

  public static void debugstart()
  {
    try {
      if(debugFile == null) {
        debugFile = new PrintWriter( new FileWriter(debugName), true); // append, autoflush
        debug("Debug starting...");
      }
    } catch(Exception e) {
    }
  }

  public static void debug(String message)
  {
    debugstart();
    try {
      Calendar rightNow = Calendar.getInstance();
      debugFile.println("[" +rightNow.getTime().toString() + "] " +message);
    } catch(Exception e) {
    }
  }

  public static void stop()
  {
    try {
      if( logFile != null )
        logFile.close();
    } catch( Exception e ) {}
    logFile = null;
  }
}