
//Title:        HSA Parents' Corner
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       Ozgur Balsoy
//Company:      
//Description:  Online Parental Access to the School Database


package hsa.util;

import hsa.db.dbHashtable;

public interface RecordParsable
{

  // This method is called for each record by the main parser
  // to handle <record> tag in the HTML teplates.
  //
  // Child classes should override this method.

  abstract public boolean handleRecord(dbHashtable fields)
       throws java.io.IOException, java.sql.SQLException;
}
