CREATE TABLE person_info_table 
     (person_id		NUMBER(6)  CONSTRAINT pk_person_info PRIMARY KEY,
      last_name 	VARCHAR2(15),
      first_name	VARCHAR2(15),
      title             VARCHAR2(8), CONSTRAINT  lower_title 
					CHECK  (title = LOWER(title)),
      user_name         VARCHAR2(8),
      address		VARCHAR2(12),
      url 		VARCHAR2(20));

CREATE TABLE phone_list_table
      (person_id 	NUMBER(6)  CONSTRAINT  fk_phone_list
				REFERENCES  person_info_table(person_id),
       phone_no		NUMBER(10),
       phone_type	VARCHAR2(10));
