CREATE TABLE elements_table 
	(Name		VARCHAR2(15) PRIMARY KEY,
      	Symbol 		VARCHAR2(3),
	Atomic_Number	NUMBER(3),
	Mass		NUMBER(10),
	Melting_Point	VARCHAR2(10),
	Boiling_Point	VARCHAR2(10),
	Number_of_PEs	NUMBER(3),
	Number_of_Ns	NUMBER(3),
	Classification	VARCHAR2(21),
	Crystal_Struct	VARCHAR2(12),
	Shells		VARCHAR2(30),
	Date_of_Disc	VARCHAR2(15),
	Discoverer	VARCHAR2(45),
	Name_Symbol_Org	VARCHAR2(60),
	Uses		VARCHAR2(75),
	Sources		VARCHAR2(75),
	Density		VARCHAR2(10),
	HeatVapor	VARCHAR2(10),
	HeatFusion	VARCHAR2(10),
	Electrical_Cond	VARCHAR2(10),
	Thermal_Cond	VARCHAR2(10),
	Specific_Heat	VARCHAR2(10),
	Group_Number	VARCHAR2(2),
	Standart_State	VARCHAR2(10),
	Colour		VARCHAR2(35),
	Meaning_of_Name	VARCHAR2(100));

CREATE TABLE URL_List
	(Name		NUMBER(15)  CONSTRAINT  xx_URL_list
				REFERENCES  elements_table(Name),
	URL		VARCHAR2(100),
	Link_Info	VARCHAR2(100));
