import java.awt.*;

public class mRound extends mPoint {
  
  public mRound( DrawCanvas _parent, 
		 int _x, int _y, int _x2, int _y2, 
		 String _color, String _fillcolor) {
    
    super(_parent, _x, _y, _x2, _y2, _color, _fillcolor);
  }
  
  public void draw(Graphics g) {
    if (fill) {
      g.setColor(parent.getHashedColor(fillcolor));
      g.fillRoundRect(x, y, x2-x, y2-y, 100, 50);
    }
    g.setColor(parent.getHashedColor(color));
    g.drawRoundRect(x, y, x2-x, y2-y, 100, 50);
  }
  
  public boolean isIn(int _x, int _y) {
    Rectangle r=new Rectangle(x, y, x2-x, y2-y);
    return r.contains(_x, _y);
  }
  
  public String toString() {
    String coor = String.valueOf(x) + " " + String.valueOf(y) + " " +
      String.valueOf(x2) + " " + String.valueOf(y2) + " ";
    
    if (fill) return "fillRoundRect " + coor + color + " " + fillcolor;
    else return "drawRoundRect " + coor + color;
  }
  
}
