// ::::::::::::::
// Paint.java
// ::::::::::::::
import java.awt.*;
import java.applet.*;
import java.util.Hashtable;

public class Paint extends Applet {
	Label Status;
	DrawCanvas c;
	Hashtable buttons;
	
    public void init() {
	setLayout(new BorderLayout());

	setBackground(Color.gray);
	setForeground(Color.black);
	buttons = new Hashtable();

	Panel w=new Panel();
	w.setLayout(new GridLayout(7,0));

	buttons.put("Rect",  new Button("Rect"));
	buttons.put("Round", new Button("Round"));
	buttons.put("Circ",  new Button("Circ"));
	buttons.put("Line",  new Button("Line"));
	buttons.put("Draw",  new Button("Draw"));
	buttons.put("Redraw",new Button("Redraw"));
	buttons.put("Clear", new Button("Clear"));

	w.add( (Button)buttons.get("Rect") );
	w.add( (Button)buttons.get("Round") );
	w.add( (Button)buttons.get("Circ") );
	w.add( (Button)buttons.get("Line") );
	w.add( (Button)buttons.get("Draw") );
	w.add( (Button)buttons.get("Redraw") );
 	w.add( (Button)buttons.get("Clear") );

	add("West", w);

	Status=new Label("Status Line");
	Panel p=new Panel();
	p.setBackground(Color.gray);
	p.add(Status);
	add("South",p);

	c=new DrawCanvas();
	c.setBackground(Color.blue);
	add("Center", c);
    }

     public void paint(Graphics g) {
		c.paint(g);
     }

    public boolean action(Event evt, Object arg) {
	String s=(String) arg;
	if (evt.target instanceof Button) {
		Status.setText(((Button)evt.target).getLabel());
		if (s.equals("Draw")) {
			((Button)evt.target).setLabel("Fill");
			c.fill=false;
		} else if (s.equals("Fill")) {
			((Button)evt.target).setLabel("Draw");
			c.fill=true;
		} else c.setDrawMode(s);
	}
	return true;
    }
}
