import java.awt.*;
import java.awt.event.*;
import com.sun.java.swing.*;

public class Toolbar extends JToolBar {
  
  public Toolbar(Paint applet) {

    setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
    //setLayout(new GridLayout(7,0));

    JButton b;
    Icon icon;
    //add(b=new JButton("Rect", new RectIcon()));
    add(b=new JButton(new RectIcon()));
    b.setActionCommand("Rect");
    b.setToolTipText("Rectangle");
    b.addActionListener(applet);	// the applet is one of the listeners
    add(b=new JButton(new RoundIcon()));
    b.setActionCommand("Round");
    b.setToolTipText("Round");
    b.addActionListener(applet);	
    add(b=new JButton(new CircleIcon()));
    b.setActionCommand("Circ");
    b.setToolTipText("Circle");
    b.addActionListener(applet);	
    add(b=new JButton(new LineIcon()));
    b.setActionCommand("Line");
    b.setToolTipText("Line");
    b.addActionListener(applet);	

    addSeparator();

    add(b=new JCheckBox("Draw"));
    b.addActionListener(applet);	
    add(b=new JButton("Redraw"));
    b.addActionListener(applet);	
    add(b=new JButton("Clear"));
    b.addActionListener(applet);	

  }
}

class ToolIcons implements Icon {
  public void paintIcon (Component c, Graphics g, 
			 int x, int y) {
  }
  public int getIconWidth() {
    return 20;
  }
  public int getIconHeight() { 
    return 20;
  }
}
class RectIcon extends ToolIcons {
  public void paintIcon (Component c, Graphics g, 
			 int x, int y) {
    g.setColor(Color.black);
    g.drawRect (x+1, y+1, getIconWidth()-2, getIconHeight()-2);
  }
}
class RoundIcon extends ToolIcons {
  public void paintIcon (Component c, Graphics g, 
			 int x, int y) {
    g.setColor(Color.black);
    g.drawRoundRect (x+1, y+1, getIconWidth()-2, getIconHeight()-2, 5, 5);
  }
}
class CircleIcon extends ToolIcons {
  public void paintIcon (Component c, Graphics g, 
			 int x, int y) {
    g.setColor(Color.black);
    g.drawOval (x+1, y+1, getIconWidth()-2, getIconHeight()-2);
  }
}
class LineIcon extends ToolIcons {
  public void paintIcon (Component c, Graphics g, 
			 int x, int y) {
    g.setColor(Color.black);
    g.drawLine (x+1, y+1, getIconWidth()-2, getIconHeight()-2);
  }
}
