import java.awt.*;
import java.applet.*;

public class JDBCmain extends Frame {

	static JDBCmain fr;							// frame that holds the applet
	static JDBCAppl app;						// applet itself

    /**
	 * Used when the JDBCAppl class is run as an application rather than an Applet.
	 */
	public static void main (String args[]) {
		fr = new JDBCmain();								// create a frame to hold the applet
		app = new JDBCAppl ();								// create an instance of the applet
		app.resize(500,500);
		fr.add ("Center", app);								// add the frame to the applet
		fr.resize (600,600);								// resize to preferred size
		app.init();											// initialize applet
		fr.show();											// make frame visible
	} // method main

	public boolean handleEvent(Event evt) {
		switch (evt.id)	{
		case Event.WINDOW_DESTROY:
			app.destroy();									// close the connection to the database
			dispose();
			System.exit(0);
			return true;
		default:
			return super.handleEvent(evt);
		}			 
	}


} // Class JDBCAppl

