import java.awt.*;
import msql.*;

public class Demo extends java.applet.Applet {

	public static void main(String[] args) {

		Demo d = new Demo();
	}

	public Demo() {

		Msql msql;

		try {
			msql = new Msql();
			msql.Connect("mama.minmet.uq.edu.au","darryl",1114);

			String dbName[] = msql.ListDBs();

			System.out.println("Databases");
			for(int i=0; i<dbName.length; i++)
				System.out.println("\t"+dbName[i]);

			msql.SelectDB("demo");

			String tableName[] = msql.ListTables();

			System.out.println("Tables in demo");
			for(int i=0; i<tableName.length; i++)
				System.out.println("\t"+tableName[i]);

			MsqlFieldDesc fieldDesc[] = msql.ListFields("host");

			System.out.println("Fields in host");
			for(int i=0; i<fieldDesc.length; i++)
				System.out.println(fieldDesc[i].toString());

			MsqlResult result = msql.Query("select * from host");
			
			String row[];

			while((row = result.FetchRow()) != null) {
				for(int i=0; i<row.length; i++)
					System.out.print("\t"+row[i]);
				System.out.println();
			}

			MsqlFieldDesc field;
			while((field = result.FetchField()) != null) 
				System.out.println(field.toString());

			fieldDesc = result.ListFields();
			System.out.println("Fields in host");
			for(int i=0; i<fieldDesc.length; i++)
				System.out.println(fieldDesc[i].toString());

			msql.Close();
		} catch(MsqlException e) {
			System.out.println(e.getMessage());
		}
	}
}
