#include <stdio.h>
#include <string.h>
#include <fstream.h>
#include <iostream.h>
#include <iomanip.h>

void help() {
	cout << "bintype [-wsh] filename" << endl;
};

int from=1, to=9999;
int size=1440000;
char filename[128];

void browse() {

  const int BUFFER=1000;
  char outputfile[128], suffix[10];
  int counter=0;
  cout << filename << " from " << from;
  if (from<to) cout << " to " << to << "\n";
  unsigned char buffer[BUFFER], *curr;
  
  ifstream f(filename, ios::in);
  long filesize, totalread=0;
  f.seekg( 0, ios::end );
  filesize=f.tellg();
  f.seekg( 0 );
  
  strcpy(outputfile, filename);
  sprintf(suffix, "%d", counter++);
  strcat(outputfile, suffix);
  if(counter>=from && counter<=to) 
	ostream o(outputfile, ios:out);

  long position=0;
  while(!f.bad() && !f.eof()) {
    f.read(buffer, BUFFER);
    
    cout << outputfile << endl;    
    totalread+=BUFFER;
    if(filesize<=totalread) {
      if(counter>=from && counter<=to) 
        o.write(buffer, BUFFER-(totalread-filesize));
      break;
    }
    o.write(buffer, BUFFER);
    o.close();

    strncpy(outputfile, filename);
    sprintf(suffix, "%d", counter++);
    strcat(outputfile, suffix);
    ostream o(outputfile, ios:out);
    if(counter>=from && counter<=to) 
	o.write(buffer, BUFFER);
  }
  o.close();
};

void readInput() {
	cin.getline(filename, 128, '\n');
	while(filename[0]) {
		browse();
		cin.getline(filename, 128, '\n');
	}
	exit;
};

void main(int argc, char* argv[]) {

  cout << argc << endl;  
  if (argc<2) readInput();

  int param=0;
  for(int i=1; i<argc; i++) {
    char *p=argv[i];
    if(p[0] == '-') {
	switch(p[1]) {
	   case 'f': from=atoi(p[2]); break;
	   case 's': size=atoi(p[2]); break;
	   case 't': to=atoi(p[2]); break;
	   case 'h': help(); exit(0);
	   default: cout << "Unknown command." << endl; help(); exit(0);
	}
    } else {
	param=1;
	strncpy(filename, p, 128);
    }
  }
  if(!param) readInput();
  else browse();
}
    
   
