// ***************************
//   Assignment #1 for cps606: testPolynomial Class
//   File:       testPolynomial.java (source code)
//   Author:     Jiangping Chen
//   Contact:    jchen06@syr.edu
// ****************************/
//  The testPolynomial class was used to test the functions of
//  Polynomial class. It has two methods for test the Polynomial and
//  get user input respectively
// ****************************

import java.io.*;

public class testPolynomial
{
	////////////////////////////////////////////////////////
	//	main
	//
	//  public static void main(String arge[])throws IOException
	//
	//	argument:       String argu[];
	//  return value :  none
	//  local value  :  int deg1
	//						for store temporary integer value
	//					Polynomial poly1,poly2, poly3,poly4,poly5
	//						store temporary polynomial for output purpose
	//
	//	This is the first method performed when program starts running. It creates
	//  polynomial objects and test all of the public functions of Polynomial class.
	//////////////////////////////////////////////////////////////
	public static void main(String argu[])throws IOException
	{
		int deg1;
		//input and test the representation the first polynomial object
		System.out.println("Please input poly1\n");
		Polynomial poly1=buildPolynomial(); //create a polynomial object
		System.out.println("\nthe degree of poly1 is: " + poly1.getDegree());
		System.out.println("the representation of Poly1 is :" + poly1.toString()+"\n");

		//input and test the representation the second polynomial object
		System.out.println("\nPlease input poly2\n");
		Polynomial poly2=buildPolynomial();
		System.out.println("\nthe degree of poly2 is: " + poly2.getDegree());
		System.out.println("the representation of poly2 is :" + poly2.toString()+"\n");

		//test addition and representation
		System.out.println("\nthe result of poly1 + poly2 : ");
		Polynomial poly3=poly1.addPo(poly2);
		System.out.println(poly3.toString()+"\n");

		//test subtraction and representation
		System.out.println("\nthe result of poly1 - poly2 : ");
		Polynomial poly4=poly1.subPo(poly2);
		System.out.println(poly4.toString()+"\n");

		//test constant multiplication
		System.out.println("\nthe result of 3*poly2 : ");
		Polynomial poly5=poly2.multPo(3);
		System.out.println(poly5.toString()+"\n");
	}


	////////////////////////////////////////////////////////
	//	buildPolynomial
	//
	//  static private Polynomial buildPolynomial()
	//
	//	argument:       none
	//  return value :  Polynomial
	//  local value  :  int deg1, count
	//						for store temporary integer value
	//					BufferedReader in
	//						for input data. throw exception when error
	//						while input
	//					Double[] coeff1;
	//						for store temporary array of coefficient
	//					Polynomial temp
	//						store temporary polynomial and for return
	//
	//	Note: 	Part of the code comes from the examples of Prof. McCracken
	//
	//	This method is used to get input for building
	//	a polynomial object
	//////////////////////////////////////////////////////////////
	static private Polynomial buildPolynomial()
	{
		int deg1;
        //set up input system
		BufferedReader in=new BufferedReader
				(new InputStreamReader (System.in));
		System.out.print("Enter the degree for Polynomial: ");
		try {  deg1 = (new Integer (in.readLine().trim())).intValue() ;}
        catch (Exception e)
        {  System.out.println("error when input degree!");
           deg1=0;  }
		double[] coeff1=new double [deg1+1];
		int count=deg1;
		while(count >=0)
		{
			System.out.print("Enter coefficient: \'input higher degree coefficient first\':");
			try { coeff1[count]=(new Double (in.readLine().trim())).doubleValue(); }
            catch (Exception e)
            {  System.out.println(" error when input coefficient!"); }
			count--;
		}
		Polynomial temp=new Polynomial(deg1,coeff1);
		return temp;
	}
}
