create or replace package wow is
	type web_page is table of varchar2(255)
	index by binary_integer;
	procedure sig;
	procedure sig(cname in varchar2);
        procedure get_page (   	thepage out web_page,
				irows in out integer );
        procedure get_page1 (   thepage out web_page,
				irows in out integer );
	--procedure showsource(cname in varchar2);
	wowgif varchar2(255) := 'NONE';
end; -- <hr>
/
create or replace package body wow is -- <p>

	invocations integer := 0;

	procedure sig is
	begin
		htp.line;
	htp.p('This page was produced by '||htf.url('http://www.npac.syr.edu/infomall/',
		htf.bold('Infomall'))||' at '||
			to_char(new_time(sysdate,'GMT','EDT'),'DY, hh24:mi mm/dd/yy "EDT"') || 
			' from NPAC ' || htf.url('http://kayak.npac.syr.edu:1963/',
			'Oracle 7 Database Server on Kayak')|| htf.nl);
	end; -- <p> 

	procedure sig(cname in varchar2) is
	begin
		sig;
		htp.url('/cgi-bin/wow/wow.showsource?cname=' || cname,
		'Inspect pl/sql source code');
	end; -- <p>

        procedure get_page (   thepage out web_page,
				irows in out integer ) is
		rc integer := 0;
		j integer;
		k integer := 1;
	begin
		if invocations = 0 and upper(wowgif) != 'NONE' then
			thepage(1):=htf.gif(wowgif);
			invocations := 1;
			k := 2;
		end if;
		for j in k..irows loop
			dbms_output.get_line(thepage(j),rc);
			if rc = 1 then
				irows := j-1;
				exit;
			end if;
		end loop;
	exception
	when others then
		raise_application_error(-20001,'wow.get_page() error ' ||
		to_char(sqlcode));
	end; -- <p>

        procedure get_page1 (   thepage out web_page,
				irows in out integer ) is
		rc integer := 0;
		j integer;
		k integer := 1;
	begin
--		if invocations = 0 and upper(wowgif) != 'NONE' then
--			thepage(1):=htf.gif(wowgif);
--			invocations := 1;
--			k := 2;
--		end if;
		for j in k..irows loop
			dbms_output.get_line(thepage(j),rc);
			if rc = 1 then
				irows := j-1;
				exit;
			end if;
		end loop;
	exception
	when others then
		raise_application_error(-20001,'wow.get_page() error ' ||
		to_char(sqlcode));
	end; -- <p>

--	procedure showsource(cname in varchar2) is
--		cursor c1 (a varchar2) is
--		select text from user_source
--		where name=upper(a) order by type, line;
--	begin
--		htp.htitle('Source code for ' || cname);
--		htp.preOpen;
--		for e in c1 (cname)loop
--			htp.p(translate(e.text,chr(10) || chr(13),'  '));
--		end loop;
--		htp.preClose;
--		sig('WOW');		
--	end; -- <p>
end;
/






