#
# mSQL Dump  (requires mSQL 2.0 Beta 5 or newer)
#
# Host: localhost    Database: w3-msql
#--------------------------------------------------------


#
# Table structure for table 'namespaces'
#
CREATE TABLE namespaces (
  namespace CHAR(50),
  descr CHAR(50)
) \g


#
# Dumping data for table 'namespaces'
#

INSERT INTO namespaces  VALUES ('SuperUser','W3-mSQL Administrators')\g

#
# Table structure for table 'areas'
#
CREATE TABLE areas (
  name CHAR(50),
  url CHAR(255),
  namespace CHAR(25)
) \g


#
# Dumping data for table 'areas'
#


#
# Table structure for table 'area_acl'
#
CREATE TABLE area_acl (
  name CHAR(50),
  offset INT,
  group CHAR(20),
  acl CHAR(50),
  namespace CHAR(25)
) \g

CREATE   INDEX idx1 ON area_acl (
	name
) \g


#
# Dumping data for table 'area_acl'
#


#
# Table structure for table 'users'
#
CREATE TABLE users (
  namespace CHAR(25),
  uname CHAR(20),
  passwd CHAR(20),
  full_name CHAR(50)
) \g

CREATE UNIQUE  INDEX idx1 ON users (
	namespace,
	uname
) \g


#
# Dumping data for table 'users'
#

INSERT INTO users  VALUES ('SuperUser','testuser','testuser','Test User')\g

#
# Table structure for table 'perms'
#
CREATE TABLE perms (
  uname CHAR(25),
  namespace CHAR(25),
  level INT
) \g

CREATE   INDEX idx1 ON perms (
	uname
) \g


#
# Dumping data for table 'perms'
#

INSERT INTO perms  VALUES ('balsoy','SuperUser',255)\g

#
# Table structure for table 'group_members'
#
CREATE TABLE group_members (
  namespace CHAR(25),
  group CHAR(20),
  uname CHAR(20)
) \g

CREATE   INDEX idx1 ON group_members (
	namespace,
	group
) \g


#
# Dumping data for table 'group_members'
#


#
# Table structure for table 'groups'
#
CREATE TABLE groups (
  namespace CHAR(25),
  group CHAR(20),
  descr CHAR(50)
) \g

CREATE   INDEX idx1 ON groups (
	namespace,
	group
) \g


#
# Dumping data for table 'groups'
#


#
# Table structure for table 'group_admin'
#
CREATE TABLE group_admin (
  namespace CHAR(25),
  group CHAR(20),
  uname CHAR(20)
) \g

CREATE   INDEX idx1 ON group_admin (
	namespace,
	group
) \g


#
# Dumping data for table 'group_admin'
#


