import java.awt.*;
import java.awt.event.*;
import com.sun.java.swing.*;

public class Toolbar extends JToolBar {
  
  public Toolbar(Paint applet) {

    setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
    //setLayout(new GridLayout(7,0));

    JButton b;
    Icon icon;
    //add(b=new JButton("Rect", new RectIcon()));
    add(b=new JButton(new RectIcon()));
    b.setActionCommand("Rect");
    b.addActionListener(applet);	// the applet is one of the listeners
    add(b=new JButton(new RoundIcon()));
    b.setActionCommand("Round");
    b.addActionListener(applet);	
    add(b=new JButton(new CircleIcon()));
    b.setActionCommand("Circ");
    b.addActionListener(applet);	
    add(b=new JButton(new LineIcon()));
    b.setActionCommand("Line");
    b.addActionListener(applet);	
    add(b=new JButton(new TextIcon()));
    b.setActionCommand("Text");
    b.addActionListener(applet);	

    addSeparator();

    add(b=new JButton("Draw"));
    b.addActionListener(applet);	
    add(b=new JButton("Redraw"));
    b.addActionListener(applet);	
    add(b=new JButton("Clear"));
    b.addActionListener(applet);	

    addSeparator();

    add(b=new JButton("Send"));
    b.addActionListener(applet);			// the applet is one of the listeners
    add(b=new JButton("Colors"));
    b.addActionListener(applet);			// the applet is one of the listeners
    add(b=new JButton("Fonts"));
    b.addActionListener(applet);			// the applet is one of the listeners
    add(b=new JButton("New"));
    b.addActionListener(applet);			// the applet is one of the listeners
    add(b=new JButton("Prev"));
    b.addActionListener(applet);			// the applet is one of the listeners
    add(b=new JButton("Next"));
    b.addActionListener(applet);			// the applet is one of the listeners	
  }
}

class ToolIcons implements Icon {
  public void paintIcon (Component c, Graphics g, 
			 int x, int y) {
  }
  public int getIconWidth() {
    return 20;
  }
  public int getIconHeight() { 
    return 20;
  }
}
class RectIcon extends ToolIcons {
  public void paintIcon (Component c, Graphics g, 
			 int x, int y) {
    g.setColor(Color.black);
    g.drawRect (x, y, getIconWidth(), getIconHeight());
  }
}
class RoundIcon extends ToolIcons {
  public void paintIcon (Component c, Graphics g, 
			 int x, int y) {
    g.setColor(Color.black);
    g.drawRoundRect (x, y, getIconWidth(), getIconHeight(), 5, 5);
  }
}
class CircleIcon extends ToolIcons {
  public void paintIcon (Component c, Graphics g, 
			 int x, int y) {
    g.setColor(Color.black);
    g.drawOval (x, y, getIconWidth(), getIconHeight());
  }
}
class LineIcon extends ToolIcons {
  public void paintIcon (Component c, Graphics g, 
			 int x, int y) {
    g.setColor(Color.black);
    g.drawLine (x, y, getIconWidth(), getIconHeight());
  }
}
class TextIcon extends ToolIcons {
  public void paintIcon (Component c, Graphics g, 
			 int x, int y) {
    g.setColor(Color.black);
    g.drawString ("T",x+8, y+8);
  }
}
