import java.awt.*;

public class mPoint {
  
  protected DrawCanvas parent;
  int x,y,x2,y2;
  boolean fill=false;
  String color, fillcolor;
  
  public mPoint( DrawCanvas _parent, 
		 int _x, int _y, int _x2, int _y2, 
		 String _color, String _fillcolor) {
    
    parent=_parent;
    x=_x;
    y=_y;
    x2=_x2;
    y2=_y2;
    color=_color;
    fillcolor=_fillcolor;
  };
  
  public void draw(Graphics g) {
    g.setColor(parent.getHashedColor(color));
    g.drawRect(x, y, x2-x, y2-y);
  }
  
  public void setFill(boolean _fill) {
    fill=_fill;
  }
  
  public boolean isIn(int _x, int _y) {
    if( x==_x && y == _y) return true;
    return false;
  }
  
  public void setEnds(int _x, int _y) {
    x2=_x;
    y2=_y;
  }
  
  public String toString() {
    return "drawLine " +  
      String.valueOf(x) + " " + String.valueOf(y) + " " +
      String.valueOf(x) + " " + String.valueOf(y) + " " + color; 
  }
}
