import java.awt.*;

public class mText extends mPoint {
  
  String data;
  Font fontInfo;
  
  public mText( DrawCanvas _parent, 
		int _x, int _y, 
		String _color) {
    
    super(_parent, _x, _y, _x, _y, _color, _color);
    data = "";
    fontInfo = null;
    
  }
  
  public void setData(String _data, Font _font) {
    data=_data;
    fontInfo=_font;
  }
  
  public void draw(Graphics g) {
    
    g.setFont(fontInfo);
    g.setColor(parent.getHashedColor(color));
    g.drawString(data, x, y);
    
  }
  
  public String toString() {
    String fontstyle=fontInfo.getName() + " " +
      (fontInfo.isBold() ? "bold" : "not-bold") + " " +
      (fontInfo.isItalic() ? "italic" : "not-italic") + " " +
      String.valueOf(fontInfo.getSize())  ; 
    
    return  "setFont " + fontstyle + "\n" +
      "drawString " +
      String.valueOf(x) + " " + String.valueOf(y) + " " + color + " " + data;
  }
  
}
