   BEGIN { FS = "," }
   NR == 1 {
      print "<HEADER>" > allf
      printf("<META NAME=%cdescription%c VALUE=%cTurkey in Pictures Archive, All on One Page%c>\n", 34, 34, 34, 34) >> allf
      printf("<META NAME=%ckeywords%c VALUE=%call images pictures%c>\n", 34, 34, 34, 34) >> allf
      printf("<META NAME=%cresource-type%c VALUE=%document%c>\n", 34, 34, 34, 34) >> allf
      printf("<META NAME=%cauthor%c VALUE=%cOzgur Balsoy%c>\n", 34, 34, 34, 34) >> allf
      print "<TITLE>Turkey In Pictures - All On One Page</TITLE>" >> allf
      print "</HEADER>\n" >> allf
      print "<H1>All On One Page</H1><HR><DL>\n" >> allf
      allpicts=0

      regs=0
      sites=0
      lets=0
      iconinfo="icons/" htaccess
      pictinfo="pictures/" htaccess
      print " " > pictinfo
      print " " > iconinfo
   }
   $1 ~ /bolge/ {
      regionfile = "" riroot "/" $2 ".html"
      print "<HEADER>" > regionfile
      printf("<TITLE>Turkey In Pictures - Regional Index - %s</TITLE>\n",$3) >> regionfile
      printf("<H1>%s</H1><HR><DL>\n",$3) >> regionfile
      regions[regs] = regionfile
      regnames[regs++] = $3
      next
   }
   $1 ~ /iller/ {
      sitefilename = "" siroot "/" $2 ".html"
      printf("<HEADER><TITLE>Turkey In Pictures - Locational Index - %s</TITLE>\n",$2) > sitefilename
      printf("<H1>%s</H1><HR><DL>\n",$2) >> sitefilename
      sitefile[sites] = sitefilename
      sitename[sites++] = $2
      next
   }
   $1 !~ /#/ { 
      if ($1 == "" || $2 == "" || $3 == "" || $4 == "") printf("Error for line:%s\n",NR)
      else {
         y=index($1,".")
         iconname= "" substr($1,1, --y) "-icon.gif"
         if ($5 == "") info = "  " $4
         else info = "  " $5 ", " $4
         if ($6 != "") info = info " - " $6
         accessinfo = info
         info = info " [" $2 "]" 
         imageinfo=sprintf("<DD><A HREF=%s/%s><IMG SRC=%s/%s>%s</A>", bigimages, $1, icons, iconname, info)
         
         regionfile = "" riroot "/" $3 ".html"
         sitefilename = "" siroot "/" $4 ".html"
         letter=substr($1, 1, 1)
         letterfilename = "" airoot "/" letter ".html"
         
         allpicts++
         regspicts[regionfile]++
         sitepicts[sitefilename]++
         letters[letter]++
         
          if (letters[letter] == 1) {
            printf("<HEADER><TITLE>Turkey In Pictures - Alphabetical Index - %s</TITLE>\n",letter) > letterfilename
            printf("<H1>Index %s</H1><HR><DL>\n",letter) >> letterfilename
            lettername[lets] = letter 
            letterfile[lets++] = letterfilename
         }
         
         print imageinfo >> allf
         print imageinfo >> regionfile
         print imageinfo >> sitefilename
         print imageinfo >> letterfilename
         printf("AddDescription %c%s%c %s\n", 34, accessinfo, 34, $1) >> pictinfo
         printf("AddDescription %c%s%c %s\n", 34, accessinfo, 34, iconname) >> iconinfo
      }
   }
   END {
      uptoindexinfo=sprintf("<A HREF=%s><IMG SRC=%s>  Back to Index Page</A>\n", upwhere, upwgif)
      lastmodified=sprintf("<HR><i>Generated by Balsoy's Image Indexer. Last modified on %s.</i>",today)
      homeinfo=sprintf("<A HREF=../index.html><IMG SRC=%s ALT=%c[Index Page]%c></A>", homegif, 34, 34)
      print "</DL><HR>" >> allf
      print homeinfo >> allf
      print uptoindexinfo >> allf
      print lastmodified >> allf
      uptoindexinfo=sprintf("<A HREF=../%s><IMG SRC=%s></A>", upwhere, upwgif)
      print "</DL><HR>" >> regions[0]
      print homeinfo >> regions[0]
      print uptoindexinfo >> regions[0]
      printf("<A HREF=%s/%s><IMG SRC=%s ALT=%c[%s]%c></A>\n", root, regions[1], fwdgif, 34, regnames[1], 34) >> regions[0]
      print lastmodified >> regions[0]
      regs--
      for(j=1; j<regs; j++) {
          printf("</DL><HR>\n") >> regions[j] 
          print homeinfo >> regions[j]
          printf("<A HREF=%s/%s><IMG SRC=%s ALT=%c[%s]%c></A>\n", root, regions[j-1], backgif, 34, regnames[j-1], 34) >> regions[j]
          print uptoindexinfo >> regions[j]
          printf("<A HREF=%s/%s><IMG SRC=%s ALT=%c[%s]%c></A>\n", root, regions[j+1], fwdgif, 34, regnames[j+1], 34) >> regions[j]
          print lastmodified >> regions[j]
      }
      printf("</DL><HR>\n") >> regions[regs]
      print homeinfo >> regions[regs]
      printf("<A HREF=%s/%s><IMG SRC=%s ALT=%c[%s]%c></A>\n", root, regions[regs-1], backgif, 34, regnames[regs-1], 34) >> regions[regs]
      print uptoindexinfo >> regions[regs]
      print lastmodified >> regions[regs]
      
      print "</DL><HR>" >> sitefile[0]
      print homeinfo >> sitefile[0]
      print uptoindexinfo >> sitefile[0]
      printf("<A HREF=%s/%s><IMG SRC=%s ALT=%c[%s]%c></A>\n", root, sitefile[1], fwdgif, 34, sitename[1], 34) >> sitefile[0]
      print lastmodified >> sitefile[0]
      sites--
      for(j=1; j<sites; j++) {
          printf("</DL><HR>\n") >> sitefile[j]
          printf("<A HREF=../index.html><IMG SRC=%s ALT=%c[Index Page]%c></A>",homegif, 34, 34) >> sitefile[j]
          printf("<A HREF=%s/%s><IMG SRC=%s ALT=%c[%s]%c></A>\n", root, sitefile[j-1], backgif, 34, sitename[j-1], 34) >> sitefile[j]
          print uptoindexinfo >> sitefile[j]
          printf("<A HREF=%s/%s><IMG SRC=%s ALT=%c[%s]%c></A>\n", root, sitefile[j+1], fwdgif, 34, sitename[j+1], 34) >> sitefile[j]
          print lastmodified >> sitefile[j]
      }
      printf("</DL><HR>\n") >> sitefile[sites]
      print homeinfo >> sitefile[sites]
      printf("<A HREF=%s/%s><IMG SRC=%s ALT=%c[%s]%c></A>\n", root, sitefile[sites-1], backgif, 34, sitename[sites-1], 34) >> sitefile[sites]
      print uptoindexinfo >> sitefile[sites]
      print lastmodified >> sitefile[sites]
      
      print "</DL><HR>" >> letterfile[0]
      print homeinfo >> letterfile[0]
      print uptoindexinfo >> letterfile[0]
      printf("<A HREF=%s/%s><IMG SRC=%s ALT=%c[%s]%c></A>\n", root, letterfile[1], fwdgif, 34, lettername[1], 34) >> letterfile[0]
      print lastmodified >> letterfile[0]
      lets--
      for(j=1; j<lets; j++) {
          printf("</DL><HR>\n") >> letterfile[j]
          printf("<A HREF=../index.html><IMG SRC=%s ALT=%c[Index Page]%c></A>", homegif, 34, 34) >> letterfile[j]
          printf("<A HREF=%s/%s><IMG SRC=%s ALT=%c[%s]%c></A>\n", root, letterfile[j-1], backgif, 34, lettername[j-1], 34) >> letterfile[j]
          print uptoindexinfo >> letterfile[j]
          printf("<A HREF=%s/%s><IMG SRC=%s ALT=%c[%s]%c></A>\n", root, letterfile[j+1], fwdgif, 34, lettername[j+1], 34) >> letterfile[j]
          print lastmodified >> letterfile[j]
      }
      printf("</DL><HR>\n") >> letterfile[lets]
      print homeinfo >> letterfile[lets]
      printf("<A HREF=%s/%s><IMG SRC=%s></A>\n", root, letterfile[lets-1], backgif, 34, lettername[lets-1], 34) >> letterfile[lets]
      print uptoindexinfo >> letterfile[lets]
      print lastmodified >> letterfile[lets]
      
      print "<HEADER><TITLE>Turkey In Pictures</TITLE></HEADER>" > upwhere
      print "<H1>Turkey In Pictures</H1><HR><b>Important:</b><br><i><img src=smallblue.gif>" >> upwhere
      print "If you'd like to download any of these images, please feel free to do so." >> upwhere
      print "If you use them on your Web pages or presentations, please put a reference to this page so that other people can get benefits of it." >> upwhere
      print "This is the only condition we have.<p>" >> upwhere
      print "<img src=smallblue.gif> If you have pictures of Turkey to share with other people," >> upwhere
      print "contact <a href=/~balsoy>me</a>.<p>" >> upwhere
      print "<img src=smallblue.gif> The numbers inside the parantheses show the numbers of the images to be loaded.</i><hr>" >> upwhere
      
      print "<H2>Regional Index</H2>" >> upwhere
      printf("<DL><DD>Choose one of the regions below or go with the ") >> upwhere
      printf("<a href=tip_mapregions.html>Sensitive Map</a> Index.<p>\n") >> upwhere
      for (i=0; i<=regs; i++) printf("<DD><A HREF =%s>%s (%s)</A>\n",regions[i],regnames[i],regspicts[regions[i]]) >> upwhere
      
      print "</DL><HR><H2>Locational Index</H2><DL><DD>" >> upwhere
      for (i=0; i<=sites; i++) {
          printf("<A HREF =%s>%s (%s)</A>",sitefile[i],sitename[i], sitepicts[sitefile[i]]) >> upwhere
          if (i==sites) printf(". \n") >> upwhere 
          else printf(", \n") >> upwhere
      }
      print "</DL><HR><H2>Alphabetical Index</H2><DL><DD>" >> upwhere
      for (i=0; i<=lets; i++) {
          printf("<A HREF =%s>%s (%s)</A>",letterfile[i],lettername[i],letters[lettername[i]]) >> upwhere
          if (i==lets) printf(". \n") >> upwhere
          else printf(", \n") >> upwhere
      }
      printf("</DL><HR><H2><A HREF =%s>All On One Page</A></H2><DL><DD>\n",allf) >> upwhere
      printf("There are %s icons whose sizes are between 8 Kb and 25 Kb on this page.\n",allpicts) >> upwhere
      print "It can be too slow to wait for all. First, you can look at the directories of" >> upwhere
      printf("<A HREF =%s>pictures</A> and <A HREF =%s>icons</A>\n",bigimages,icons) >> upwhere
      print "with their size information here." >> upwhere
      print "</DL><HR><a href=index.html><IMG SRC=trhome.gif></a><IMG SRC=mail.gif><i>" >> upwhere
      print "Please send your comments and suggestions to <a href=whosupports.html>us</a>. " >> upwhere
      print lastmodified >> upwhere 
}
